/**
 */
package de.uks.se.scenariodiagram.impl;

import de.uks.se.scenariodiagram.ScenarioAttribute;
import de.uks.se.scenariodiagram.ScenarioDiagram;
import de.uks.se.scenariodiagram.ScenarioLink;
import de.uks.se.scenariodiagram.ScenarioObject;
import de.uks.se.scenariodiagram.ScenariodiagramPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Scenario Object</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.uks.se.scenariodiagram.impl.ScenarioObjectImpl#getObjectType <em>Object Type</em>}</li>
 *   <li>{@link de.uks.se.scenariodiagram.impl.ScenarioObjectImpl#getParentDiagram <em>Parent Diagram</em>}</li>
 *   <li>{@link de.uks.se.scenariodiagram.impl.ScenarioObjectImpl#getContainedScenarioObjects <em>Contained Scenario Objects</em>}</li>
 *   <li>{@link de.uks.se.scenariodiagram.impl.ScenarioObjectImpl#getParent <em>Parent</em>}</li>
 *   <li>{@link de.uks.se.scenariodiagram.impl.ScenarioObjectImpl#getAttributes <em>Attributes</em>}</li>
 *   <li>{@link de.uks.se.scenariodiagram.impl.ScenarioObjectImpl#getLinks <em>Links</em>}</li>
 *   <li>{@link de.uks.se.scenariodiagram.impl.ScenarioObjectImpl#getOutgoingLinks <em>Outgoing Links</em>}</li>
 *   <li>{@link de.uks.se.scenariodiagram.impl.ScenarioObjectImpl#getIncomingLinks <em>Incoming Links</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ScenarioObjectImpl extends MinimalEObjectImpl.Container implements ScenarioObject
{
  /**
   * The cached value of the '{@link #getObjectType() <em>Object Type</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getObjectType()
   * @generated
   * @ordered
   */
  protected EClass objectType;

  /**
   * The cached value of the '{@link #getContainedScenarioObjects() <em>Contained Scenario Objects</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getContainedScenarioObjects()
   * @generated
   * @ordered
   */
  protected EList<ScenarioObject> containedScenarioObjects;

  /**
   * The cached value of the '{@link #getAttributes() <em>Attributes</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAttributes()
   * @generated
   * @ordered
   */
  protected EList<ScenarioAttribute> attributes;

  /**
   * The cached value of the '{@link #getLinks() <em>Links</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLinks()
   * @generated
   * @ordered
   */
  protected EList<ScenarioLink> links;

  /**
   * The cached value of the '{@link #getOutgoingLinks() <em>Outgoing Links</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOutgoingLinks()
   * @generated
   * @ordered
   */
  protected EList<ScenarioLink> outgoingLinks;

  /**
   * The cached value of the '{@link #getIncomingLinks() <em>Incoming Links</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getIncomingLinks()
   * @generated
   * @ordered
   */
  protected EList<ScenarioLink> incomingLinks;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ScenarioObjectImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return ScenariodiagramPackage.Literals.SCENARIO_OBJECT;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getObjectType()
  {
    if (objectType != null && objectType.eIsProxy())
    {
      InternalEObject oldObjectType = (InternalEObject)objectType;
      objectType = (EClass)eResolveProxy(oldObjectType);
      if (objectType != oldObjectType)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, ScenariodiagramPackage.SCENARIO_OBJECT__OBJECT_TYPE, oldObjectType, objectType));
      }
    }
    return objectType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass basicGetObjectType()
  {
    return objectType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setObjectType(EClass newObjectType)
  {
    EClass oldObjectType = objectType;
    objectType = newObjectType;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ScenariodiagramPackage.SCENARIO_OBJECT__OBJECT_TYPE, oldObjectType, objectType));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ScenarioDiagram getParentDiagram()
  {
    if (eContainerFeatureID() != ScenariodiagramPackage.SCENARIO_OBJECT__PARENT_DIAGRAM) return null;
    return (ScenarioDiagram)eContainer();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ScenarioDiagram basicGetParentDiagram()
  {
    if (eContainerFeatureID() != ScenariodiagramPackage.SCENARIO_OBJECT__PARENT_DIAGRAM) return null;
    return (ScenarioDiagram)eInternalContainer();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetParentDiagram(ScenarioDiagram newParentDiagram, NotificationChain msgs)
  {
    msgs = eBasicSetContainer((InternalEObject)newParentDiagram, ScenariodiagramPackage.SCENARIO_OBJECT__PARENT_DIAGRAM, msgs);
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setParentDiagram(ScenarioDiagram newParentDiagram)
  {
    if (newParentDiagram != eInternalContainer() || (eContainerFeatureID() != ScenariodiagramPackage.SCENARIO_OBJECT__PARENT_DIAGRAM && newParentDiagram != null))
    {
      if (EcoreUtil.isAncestor(this, newParentDiagram))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eInternalContainer() != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newParentDiagram != null)
        msgs = ((InternalEObject)newParentDiagram).eInverseAdd(this, ScenariodiagramPackage.SCENARIO_DIAGRAM__CONTAINED_SCENARIO_OBJECTS, ScenarioDiagram.class, msgs);
      msgs = basicSetParentDiagram(newParentDiagram, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ScenariodiagramPackage.SCENARIO_OBJECT__PARENT_DIAGRAM, newParentDiagram, newParentDiagram));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ScenarioObject> getContainedScenarioObjects()
  {
    if (containedScenarioObjects == null)
    {
      containedScenarioObjects = new EObjectContainmentWithInverseEList<ScenarioObject>(ScenarioObject.class, this, ScenariodiagramPackage.SCENARIO_OBJECT__CONTAINED_SCENARIO_OBJECTS, ScenariodiagramPackage.SCENARIO_OBJECT__PARENT);
    }
    return containedScenarioObjects;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ScenarioObject getParent()
  {
    if (eContainerFeatureID() != ScenariodiagramPackage.SCENARIO_OBJECT__PARENT) return null;
    return (ScenarioObject)eContainer();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ScenarioObject basicGetParent()
  {
    if (eContainerFeatureID() != ScenariodiagramPackage.SCENARIO_OBJECT__PARENT) return null;
    return (ScenarioObject)eInternalContainer();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetParent(ScenarioObject newParent, NotificationChain msgs)
  {
    msgs = eBasicSetContainer((InternalEObject)newParent, ScenariodiagramPackage.SCENARIO_OBJECT__PARENT, msgs);
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setParent(ScenarioObject newParent)
  {
    if (newParent != eInternalContainer() || (eContainerFeatureID() != ScenariodiagramPackage.SCENARIO_OBJECT__PARENT && newParent != null))
    {
      if (EcoreUtil.isAncestor(this, newParent))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eInternalContainer() != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newParent != null)
        msgs = ((InternalEObject)newParent).eInverseAdd(this, ScenariodiagramPackage.SCENARIO_OBJECT__CONTAINED_SCENARIO_OBJECTS, ScenarioObject.class, msgs);
      msgs = basicSetParent(newParent, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ScenariodiagramPackage.SCENARIO_OBJECT__PARENT, newParent, newParent));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ScenarioAttribute> getAttributes()
  {
    if (attributes == null)
    {
      attributes = new EObjectContainmentWithInverseEList<ScenarioAttribute>(ScenarioAttribute.class, this, ScenariodiagramPackage.SCENARIO_OBJECT__ATTRIBUTES, ScenariodiagramPackage.SCENARIO_ATTRIBUTE__OBJECT);
    }
    return attributes;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ScenarioLink> getLinks()
  {
    if (links == null)
    {
      links = new EObjectContainmentWithInverseEList<ScenarioLink>(ScenarioLink.class, this, ScenariodiagramPackage.SCENARIO_OBJECT__LINKS, ScenariodiagramPackage.SCENARIO_LINK__PARENT);
    }
    return links;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ScenarioLink> getOutgoingLinks()
  {
    if (outgoingLinks == null)
    {
      outgoingLinks = new EObjectWithInverseResolvingEList<ScenarioLink>(ScenarioLink.class, this, ScenariodiagramPackage.SCENARIO_OBJECT__OUTGOING_LINKS, ScenariodiagramPackage.SCENARIO_LINK__SOURCE);
    }
    return outgoingLinks;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ScenarioLink> getIncomingLinks()
  {
    if (incomingLinks == null)
    {
      incomingLinks = new EObjectWithInverseResolvingEList<ScenarioLink>(ScenarioLink.class, this, ScenariodiagramPackage.SCENARIO_OBJECT__INCOMING_LINKS, ScenariodiagramPackage.SCENARIO_LINK__TARGET);
    }
    return incomingLinks;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case ScenariodiagramPackage.SCENARIO_OBJECT__PARENT_DIAGRAM:
        if (eInternalContainer() != null)
          msgs = eBasicRemoveFromContainer(msgs);
        return basicSetParentDiagram((ScenarioDiagram)otherEnd, msgs);
      case ScenariodiagramPackage.SCENARIO_OBJECT__CONTAINED_SCENARIO_OBJECTS:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getContainedScenarioObjects()).basicAdd(otherEnd, msgs);
      case ScenariodiagramPackage.SCENARIO_OBJECT__PARENT:
        if (eInternalContainer() != null)
          msgs = eBasicRemoveFromContainer(msgs);
        return basicSetParent((ScenarioObject)otherEnd, msgs);
      case ScenariodiagramPackage.SCENARIO_OBJECT__ATTRIBUTES:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getAttributes()).basicAdd(otherEnd, msgs);
      case ScenariodiagramPackage.SCENARIO_OBJECT__LINKS:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getLinks()).basicAdd(otherEnd, msgs);
      case ScenariodiagramPackage.SCENARIO_OBJECT__OUTGOING_LINKS:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getOutgoingLinks()).basicAdd(otherEnd, msgs);
      case ScenariodiagramPackage.SCENARIO_OBJECT__INCOMING_LINKS:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getIncomingLinks()).basicAdd(otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case ScenariodiagramPackage.SCENARIO_OBJECT__PARENT_DIAGRAM:
        return basicSetParentDiagram(null, msgs);
      case ScenariodiagramPackage.SCENARIO_OBJECT__CONTAINED_SCENARIO_OBJECTS:
        return ((InternalEList<?>)getContainedScenarioObjects()).basicRemove(otherEnd, msgs);
      case ScenariodiagramPackage.SCENARIO_OBJECT__PARENT:
        return basicSetParent(null, msgs);
      case ScenariodiagramPackage.SCENARIO_OBJECT__ATTRIBUTES:
        return ((InternalEList<?>)getAttributes()).basicRemove(otherEnd, msgs);
      case ScenariodiagramPackage.SCENARIO_OBJECT__LINKS:
        return ((InternalEList<?>)getLinks()).basicRemove(otherEnd, msgs);
      case ScenariodiagramPackage.SCENARIO_OBJECT__OUTGOING_LINKS:
        return ((InternalEList<?>)getOutgoingLinks()).basicRemove(otherEnd, msgs);
      case ScenariodiagramPackage.SCENARIO_OBJECT__INCOMING_LINKS:
        return ((InternalEList<?>)getIncomingLinks()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs)
  {
    switch (eContainerFeatureID())
    {
      case ScenariodiagramPackage.SCENARIO_OBJECT__PARENT_DIAGRAM:
        return eInternalContainer().eInverseRemove(this, ScenariodiagramPackage.SCENARIO_DIAGRAM__CONTAINED_SCENARIO_OBJECTS, ScenarioDiagram.class, msgs);
      case ScenariodiagramPackage.SCENARIO_OBJECT__PARENT:
        return eInternalContainer().eInverseRemove(this, ScenariodiagramPackage.SCENARIO_OBJECT__CONTAINED_SCENARIO_OBJECTS, ScenarioObject.class, msgs);
    }
    return super.eBasicRemoveFromContainerFeature(msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case ScenariodiagramPackage.SCENARIO_OBJECT__OBJECT_TYPE:
        if (resolve) return getObjectType();
        return basicGetObjectType();
      case ScenariodiagramPackage.SCENARIO_OBJECT__PARENT_DIAGRAM:
        if (resolve) return getParentDiagram();
        return basicGetParentDiagram();
      case ScenariodiagramPackage.SCENARIO_OBJECT__CONTAINED_SCENARIO_OBJECTS:
        return getContainedScenarioObjects();
      case ScenariodiagramPackage.SCENARIO_OBJECT__PARENT:
        if (resolve) return getParent();
        return basicGetParent();
      case ScenariodiagramPackage.SCENARIO_OBJECT__ATTRIBUTES:
        return getAttributes();
      case ScenariodiagramPackage.SCENARIO_OBJECT__LINKS:
        return getLinks();
      case ScenariodiagramPackage.SCENARIO_OBJECT__OUTGOING_LINKS:
        return getOutgoingLinks();
      case ScenariodiagramPackage.SCENARIO_OBJECT__INCOMING_LINKS:
        return getIncomingLinks();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case ScenariodiagramPackage.SCENARIO_OBJECT__OBJECT_TYPE:
        setObjectType((EClass)newValue);
        return;
      case ScenariodiagramPackage.SCENARIO_OBJECT__PARENT_DIAGRAM:
        setParentDiagram((ScenarioDiagram)newValue);
        return;
      case ScenariodiagramPackage.SCENARIO_OBJECT__CONTAINED_SCENARIO_OBJECTS:
        getContainedScenarioObjects().clear();
        getContainedScenarioObjects().addAll((Collection<? extends ScenarioObject>)newValue);
        return;
      case ScenariodiagramPackage.SCENARIO_OBJECT__PARENT:
        setParent((ScenarioObject)newValue);
        return;
      case ScenariodiagramPackage.SCENARIO_OBJECT__ATTRIBUTES:
        getAttributes().clear();
        getAttributes().addAll((Collection<? extends ScenarioAttribute>)newValue);
        return;
      case ScenariodiagramPackage.SCENARIO_OBJECT__LINKS:
        getLinks().clear();
        getLinks().addAll((Collection<? extends ScenarioLink>)newValue);
        return;
      case ScenariodiagramPackage.SCENARIO_OBJECT__OUTGOING_LINKS:
        getOutgoingLinks().clear();
        getOutgoingLinks().addAll((Collection<? extends ScenarioLink>)newValue);
        return;
      case ScenariodiagramPackage.SCENARIO_OBJECT__INCOMING_LINKS:
        getIncomingLinks().clear();
        getIncomingLinks().addAll((Collection<? extends ScenarioLink>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case ScenariodiagramPackage.SCENARIO_OBJECT__OBJECT_TYPE:
        setObjectType((EClass)null);
        return;
      case ScenariodiagramPackage.SCENARIO_OBJECT__PARENT_DIAGRAM:
        setParentDiagram((ScenarioDiagram)null);
        return;
      case ScenariodiagramPackage.SCENARIO_OBJECT__CONTAINED_SCENARIO_OBJECTS:
        getContainedScenarioObjects().clear();
        return;
      case ScenariodiagramPackage.SCENARIO_OBJECT__PARENT:
        setParent((ScenarioObject)null);
        return;
      case ScenariodiagramPackage.SCENARIO_OBJECT__ATTRIBUTES:
        getAttributes().clear();
        return;
      case ScenariodiagramPackage.SCENARIO_OBJECT__LINKS:
        getLinks().clear();
        return;
      case ScenariodiagramPackage.SCENARIO_OBJECT__OUTGOING_LINKS:
        getOutgoingLinks().clear();
        return;
      case ScenariodiagramPackage.SCENARIO_OBJECT__INCOMING_LINKS:
        getIncomingLinks().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case ScenariodiagramPackage.SCENARIO_OBJECT__OBJECT_TYPE:
        return objectType != null;
      case ScenariodiagramPackage.SCENARIO_OBJECT__PARENT_DIAGRAM:
        return basicGetParentDiagram() != null;
      case ScenariodiagramPackage.SCENARIO_OBJECT__CONTAINED_SCENARIO_OBJECTS:
        return containedScenarioObjects != null && !containedScenarioObjects.isEmpty();
      case ScenariodiagramPackage.SCENARIO_OBJECT__PARENT:
        return basicGetParent() != null;
      case ScenariodiagramPackage.SCENARIO_OBJECT__ATTRIBUTES:
        return attributes != null && !attributes.isEmpty();
      case ScenariodiagramPackage.SCENARIO_OBJECT__LINKS:
        return links != null && !links.isEmpty();
      case ScenariodiagramPackage.SCENARIO_OBJECT__OUTGOING_LINKS:
        return outgoingLinks != null && !outgoingLinks.isEmpty();
      case ScenariodiagramPackage.SCENARIO_OBJECT__INCOMING_LINKS:
        return incomingLinks != null && !incomingLinks.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //ScenarioObjectImpl
